//
//  BoardManager.m
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import "BoardCellKoma.h"
#import "BoardManager.h"
#import "Adapter.h"
#import "BoardCell.h"
#import "YKifController.h"

@implementation BoardManager

int hirate1[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_NARIKYOU,SENTE_NARIKEI,SENTE_NARIGIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_UMA,0,0,0,0,0,SENTE_RYU,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_TO,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_TO,SENTE_TO,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,GOTE_RYU,0,0,0,0,0,GOTE_UMA,0,-99,0,-99,0,-99,-99},
   
    {-99,GOTE_KYOUSYA,GOTE_KEIMA,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,GOTE_KEIMA,GOTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

int hirate[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,GOTE_HISYA,0,0,0,0,0,GOTE_KAKU,0,-99,0,-99,0,-99,-99},
   
    {-99,GOTE_KYOUSYA,GOTE_KEIMA,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,GOTE_KEIMA,GOTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

int kyouoti[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,GOTE_HISYA,0,0,0,0,0,GOTE_KAKU,0,-99,0,-99,0,-99,-99},
   
    {-99,GOTE_KYOUSYA,GOTE_KEIMA,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,GOTE_KEIMA,0,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

int kakuoti[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,GOTE_HISYA,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},
   
    {-99,GOTE_KYOUSYA,GOTE_KEIMA,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,GOTE_KEIMA,GOTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

int hisyaoti[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,GOTE_KAKU,0,-99,0,-99,0,-99,-99},
   
    {-99,GOTE_KYOUSYA,GOTE_KEIMA,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,GOTE_KEIMA,GOTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

int hisyakyouoti[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,GOTE_KAKU,0,-99,0,-99,0,-99,-99},
   
    {-99,GOTE_KYOUSYA,GOTE_KEIMA,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,GOTE_KEIMA,0,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

int nimaioti[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},
   
    {-99,GOTE_KYOUSYA,GOTE_KEIMA,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,GOTE_KEIMA,GOTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

int yonmaioti[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},
   
    {-99,0,GOTE_KEIMA,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,GOTE_KEIMA,0,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

int rokumaioti[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},
   
    {-99,0,0,GOTE_GIN,GOTE_KIN,GOTE_OU,
    GOTE_KIN,GOTE_GIN,0,0,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

int hatimaioti[MAX_HEIGHT][MAX_WIDTH] = {
    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99},

    {-99,SENTE_KYOUSYA,SENTE_KEIMA,SENTE_GIN,SENTE_KIN,SENTE_OU,
    SENTE_KIN,SENTE_GIN,SENTE_KEIMA,SENTE_KYOUSYA,-99,0,-99,-99,-99,-99},

    {-99,0,SENTE_KAKU,0,0,0,0,0,SENTE_HISYA,0,-99,0,-99,0,-99,-99},
   
    {-99,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,SENTE_FU,
    SENTE_FU,SENTE_FU,SENTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,-99,-99,-99,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},

    {-99,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,GOTE_FU,
    GOTE_FU,GOTE_FU,GOTE_FU,-99,0,-99,0,-99,-99},

    {-99,0,0,0,0,0,0,0,0,0,-99,0,-99,0,-99,-99},
   
    {-99,0,0,0,GOTE_KIN,GOTE_OU,
    GOTE_KIN,0,0,0,-99,0,-99,-99,-99,-99},

    {-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99,-99}
};

- (id)init {
    self = [super init];
    [self initBoardManager:TEAI_HIRATE];
    return self;
}

// 
- (void)initBoardManager:(int)teaiwari {
    int i, j;
    
    for (i=0; i<MAX_WIDTH; i++) {
        for (j=0; j<MAX_HEIGHT; j++) {
            [_board[i][j] release];
            switch (teaiwari) {
                case TEAI_HIRATE:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :hirate[j][i] : NO];
                    break;
                case TEAI_KYOUOTI:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :kyouoti[j][i] : NO];
                    break;
                case TEAI_KAKUOTI:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :kakuoti[j][i] : NO];
                    break;
                case TEAI_HISYAOTI:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :hisyaoti[j][i] : NO];
                    break;
                case TEAI_HISYAKYOUOTI:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :hisyakyouoti[j][i] : NO];
                    break;
                case TEAI_NIMAIOTI:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :nimaioti[j][i] : NO];
                    break;
                case TEAI_YONMAIOTI:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :yonmaioti[j][i] : NO];
                    break;
                case TEAI_ROKUMAIOTI:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :rokumaioti[j][i] : NO];
                    break;

                case TEAI_HATIMAIOTI:
                    _board[i][j] = [[BoardCell alloc] initBoardCell:i :j 
                                    :hatimaioti[j][i] : NO];
                    break;

            }
        }
    }
    
    [_boardDrag release];
    _boardDrag = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];
    [_boardStock release];
    _boardStock = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];
    [_boardSheetDrag release];
    _boardSheetDrag = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];
    [_boardSource release];
    _boardSource = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];
    [_boardDestination release];
    _boardDestination = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];
    [_boardPlace release];
    _boardPlace = [[BoardCell alloc] initBoardCell:0 :0 :KOMA_NASHI : NO];    
}

- (void)frontStepKif:(BoardCell *)selectSource :(BoardCell *)selectDestination
    :(BoardCell *)placeSource :(BoardCell *)placeDestination {
    int x1,y1;

    x1 = [selectSource boardCellX];
    y1 = [selectSource boardCellY];

    if ((x1 > 10) && ([_board[x1][y1] boardCellCount] != 1)) {
        [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] - 1];
    } else {
        [_board[x1][y1] eraseBoardCell];
    }
    
    x1 = [placeSource boardCellX];
    y1 = [placeSource boardCellY];
    [_board[x1][y1] eraseBoardCell];

    x1 = [selectDestination boardCellX];
    y1 = [selectDestination boardCellY];
    [_board[x1][y1] boardCellCopyExceptCount:selectDestination];
    [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] + 1];

 //   [_board[x1][y1] printBoardCell];

    if ([placeDestination boardCellKomaKind] != KOMA_NASHI) { 
        x1 = [placeDestination boardCellX];
        y1 = [placeDestination boardCellY];
        [_board[x1][y1] boardCellCopyExceptCount:placeDestination];
        [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] + 1];    
    }
    
    [_boardDestination boardCellCopy:selectDestination];
}

- (void)backStepKif:(BoardCell *)selectSrc :(BoardCell *)selectDest
    :(BoardCell *)placeSrc :(BoardCell *)placeDest 
    :(BoardCell *)selectSrc1 :(BoardCell *)selectDest1
    :(BoardCell *)placeSrc1 :(BoardCell *)placeDest1 {
    int x1,y1;

    x1 = [selectSrc boardCellX];
    y1 = [selectSrc boardCellY];
    if (x1 < 10) {
        [_board[x1][y1] boardCellCopy:selectSrc];
    } else if (x1 > 10) {
        [_board[x1][y1] boardCellCopyExceptCount:selectSrc];
        [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] + 1];
    }
    

    x1 = [placeDest boardCellX];
    y1 = [placeDest boardCellY];
    if ((x1 > 10) && ([_board[x1][y1] boardCellCount] != 1)) {
        [_board[x1][y1] boardCellCopyExceptCount:placeDest];
        [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] - 1];
    } else {
        [_board[x1][y1] eraseBoardCell];
    }

    x1 = [placeSrc boardCellX];
    y1 = [placeSrc boardCellY];
    [_board[x1][y1] boardCellCopy:placeSrc];

    if (selectDest1 == nil) {
        [_boardDestination eraseBoardCell];
    } else {
        [_boardDestination boardCellCopy:selectDest1];
    }
    
/*    [selectSrc printBoardCell];
    [selectDest printBoardCell];
    [placeSrc printBoardCell];
    [placeDest printBoardCell];
*/
}

- (void)drawBoard {
    int i,j;
    int komaKind;
    
    [_adapter drawBackBoard];

    [_adapter drawBoardSelectBacckImage:_boardDestination];

    for (i=0; i<MAX_WIDTH; i++) {
        for (j=0; j<MAX_HEIGHT; j++) {
            [_adapter drawKoma:_board[i][j]];
        }
    }

    komaKind = [_ykifController startKomaKind];
  
    if (komaKind != 0) {
        [_adapter drawSenteGote:komaKind];
    }
}

- (int)getKomaKind:(int)x :(int)y {
    return [_board[x][y] boardCellKomaKind];
}

// ɖ߂
- (void)moveBoardDrag:(int)x :(int)y {
    int x1,y1;
    int moveKomaKind, komaKind;
    NSImage *image;
       
    moveKomaKind = [_board[x][y] boardCellKomaKind];
    komaKind = [_boardDrag boardCellKomaKind];
	
// ւ̃hbv֎~
	if (x > 10) {
			[self moveBackBoardDrag];
// ՈȊOւ̃hbv֎~	
	} else if (moveKomaKind == KOMA_WAKU) {
        [self moveBackBoardDrag];
//  ̏
	// ̋ꍇ	
	}	else if (([_boardDrag boardCellX] > 10) && ((komaKind * moveKomaKind) < 0)) {
        [self moveBackBoardDrag];
	// ̋ꍇ	
	} else if (([_boardDrag boardCellX] > 10) && ((komaKind * moveKomaKind) > 0)) {
        [self moveBackBoardDrag];
	// Ȃꍇ
	} else if (([_boardDrag boardCellX] > 10) && ((komaKind * moveKomaKind) == 0)) {
        if ([self canPut:x :y] == YES) {

            [_boardStock boardCellCopy:_board[x][y]];
            [_boardPlace boardCellCopy:_boardStock];

            [_boardDrag setBoardCellX:x];
            [_boardDrag setBoardCellY:y];
            [_board[x][y] boardCellCopy:_boardDrag];
            [_boardDestination boardCellCopy:_boardDrag]; 

           [self makeKif];

            [_boardDrag eraseBoardCell];    
        } else { 
            [self moveBackBoardDrag];
        }
// Տ̋̏
	// ̈ʒuɃhbv
	} else if (([_boardDrag boardCellX] == x) && ([_boardDrag boardCellY] == y)) {
        [_boardDrag setBoardCellX:x];
        [_boardDrag setBoardCellY:y];
        [_board[x][y] boardCellCopy:_boardDrag];
        [_boardDrag eraseBoardCell];    
	// ̋ꍇ
	} else if ((komaKind * moveKomaKind) > 0) {
        [self moveBackBoardDrag];    
	// G̋ꍇ
	// Ȃꍇ
	// ꍇ
	// Ȃꍇ		
	} else if ([self canMove:x :y] == YES) {
		
		// ړ̋ۑ
		[_boardStock boardCellCopyExceptCount:_board[x][y]];
        if ([_boardStock boardCellKomaKind] != KOMA_NASHI)
            [_boardStock setBoardCellCount:1];

        [_boardPlace boardCellCopy:_boardStock];
        
		// ߂
		// i[Ăʒuݒ
		[_boardStock reversePromote];
        
        if ([_boardDrag canPromote:x :y] == YES) {
                [_boardSheetDrag boardCellCopy:_boardDrag];
                [_boardSheetDrag setBoardCellX:x];
                [_boardSheetDrag setBoardCellY:y];

            if ([_boardDrag canAutoPromote:x :y] == YES) {
				
				[_boardSheetDrag promote];

                [_boardDestination boardCellCopy:_boardSheetDrag]; 

                if ([_boardStock boardCellKomaKind] != KOMA_NASHI) {
                    x1 = [_boardStock boardCellX];
                    y1 = [_boardStock boardCellY];    
                    [_board[x1][y1] boardCellCopyExceptCount:_boardStock];
                    [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount]
                     + 1];
                }
                
                x1 = [_boardSheetDrag boardCellX];
                y1 = [_boardSheetDrag boardCellY];    
                [_board[x1][y1] boardCellCopy:_boardSheetDrag];
                [_boardSheetDrag eraseBoardCell];
                [_boardDrag eraseBoardCell];

                [self makeKif];

            } else {
                image = [_adapter getKomaImageKind: [_boardDrag boardCellKomaKind]];
              
                [_promoteImageView setImage:image];
                [NSApp beginSheet:_promoteWindow 
                    modalForWindow:_boardWindow 
                    modalDelegate:self
                    didEndSelector:@selector(sheetDidEnd:returnCode:contextInfo:)
                    contextInfo:nil];
            }
        } else {
            if ([_boardStock boardCellKomaKind] != KOMA_NASHI) {
                x1 = [_boardStock boardCellX];
                y1 = [_boardStock boardCellY];    
                [_board[x1][y1] boardCellCopyExceptCount:_boardStock];
                [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] + 1];
            }
            
            [_boardDrag setBoardCellX:x];
            [_boardDrag setBoardCellY:y];
            [_board[x][y] boardCellCopy:_boardDrag];
            
            [_boardDestination boardCellCopy:_boardDrag]; 
            [self makeKif];

            [_boardDrag eraseBoardCell];
        } 
    } else {
        [self moveBackBoardDrag];
    }
}

// V[gȈ
- (void)sheetDidEnd:(NSWindow *)sheet 
            returnCode:(int)returnCode
            contextInfo:(void *)contextInfo {
    int x1,y1;

    if (returnCode == 1)
        [_boardSheetDrag promote];
        
//NSLog(@"%d",[_boardSheetDrag boardCellKomaKind]);    
	
	// i[
	if ([_boardStock boardCellKomaKind] != KOMA_NASHI) {
        x1 = [_boardStock boardCellX];
        y1 = [_boardStock boardCellY];    
        [_board[x1][y1] boardCellCopyExceptCount:_boardStock];
        [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] + 1];
    }
    
	// (Ȃ)u
	x1 = [_boardSheetDrag boardCellX];
    y1 = [_boardSheetDrag boardCellY];    
    [_board[x1][y1] boardCellCopy:_boardSheetDrag];

    [_boardDestination boardCellCopy:_boardSheetDrag]; 

    [self makeKif];

    [_boardSheetDrag eraseBoardCell];
    [_boardDrag eraseBoardCell];
    
    [_boardView setNeedsDisplay:YES];
}

- (IBAction)endPromoteYes:(id)sender {
    [_promoteWindow orderOut:sender];
    [NSApp endSheet:_promoteWindow returnCode:1];
}

- (IBAction)endPromoteNo:(id)sender {
    [_promoteWindow orderOut:sender];
    [NSApp endSheet:_promoteWindow returnCode:2];
}

// draggingRntered
- (void)enterBoardDrag:(int)x :(int)y {
    int x1,y1;

    if ([_boardDrag boardCellCount] == 1) {
        x1 = [_boardDrag boardCellX];
        y1 = [_boardDrag boardCellY];    
        
        if ([_board[x1][y1] boardCellCount] == 1) {
            [_board[x1][y1] eraseBoardCell];
        } else {
            [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] - 1];
        }
    } else if ([_board[x][y] boardCellCount] != 0) {
        [_boardDrag boardCellCopyExceptCount:_board[x][y]];
        [_boardDrag setBoardCellCount:1];        

        [_boardSource boardCellCopy:_boardDrag];

        if ([_board[x][y] boardCellCount] == 1) {
            [_board[x][y] eraseBoardCell];
        } else {
            [_board[x][y] setBoardCellCount:[_board[x][y] boardCellCount] - 1];
        }
    }
}

- (void)exitBoardDrag {
    int x1,y1;

    x1 = [_boardDrag boardCellX];
    y1 = [_boardDrag boardCellY];    
    [_board[x1][y1] boardCellCopyExceptCount:_boardDrag];
    [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] + 1];        

}

- (void)moveBackBoardDrag {
    int x1,y1;

    x1 = [_boardDrag boardCellX];
    y1 = [_boardDrag boardCellY];
    [_board[x1][y1] boardCellCopyExceptCount:_boardDrag];
    [_board[x1][y1] setBoardCellCount:[_board[x1][y1] boardCellCount] + 1];
    
    [_boardDrag eraseBoardCell];
}

// łƂł邩H
- (BOOL)canPut:(int)x :(int)y {
    int komaKind;
    int i;
    BOOL flag = YES;
    
    komaKind = [_boardDrag boardCellKomaKind];

    switch (komaKind) {
        case SENTE_KEIMA:
            if (y > 7)
                flag = NO;
            break;
        case SENTE_KYOUSYA:
            if (y == 9)
                flag = NO;
            break;
        case SENTE_FU:
            if (y == 9) {
                flag = NO;
                break;
            } else {
                for (i=0;i<MAX_HEIGHT;i++) {
                    if ([_board[x][i] boardCellKomaKind] == komaKind) {
                        flag = NO;
                    }
                }
                break;
            }
            break;
        case GOTE_KEIMA:
            if (y < 3)
                flag = NO;
            break;
        case GOTE_KYOUSYA:
            if (y == 1)
                flag = NO;
            break;
        case GOTE_FU:
            if (y == 1) {
                flag = NO;
                break;
            } else {
                for (i=0;i<MAX_HEIGHT;i++) {
                    if ([_board[x][i] boardCellKomaKind] == komaKind) {
                        flag = NO;
                    }
                }
                break;
            }
    }
    return flag;
}

// ̈ʒuɋړł邩
- (BOOL)canMove:(int)x :(int)y {
    int komaKind;
    BOOL flag = YES;
    int x1,y1;
    int i,j;
    int mx,my;
    
    komaKind = [_boardDrag boardCellKomaKind];
	// ړ̍W
	x1 = [_boardDrag boardCellX];
    y1 = [_boardDrag boardCellY];
    
    switch (komaKind) {
        case SENTE_OU:
        case GOTE_OU:
            if ((((x1-1) <= x) && (x <= (x1+1))) &&
                (((y1-1) <= y) && (y <= (y1+1)))) {
                flag = YES;
            } else {
                flag = NO;
            }
            break;
        case SENTE_RYU:	
        case GOTE_RYU:
            if ((((x1-1) <= x) && (x <= (x1+1))) &&
                (((y1-1) <= y) && (y <= (y1+1)))) {
                flag = YES;
                break;
            }
        case SENTE_HISYA:
        case GOTE_HISYA:
            flag = YES;
            if ((x == x1) && (y<y1)) {
                for (i=(y+1); i<y1; i++) {
                    if ([_board[x][i] boardCellKomaKind] != KOMA_NASHI) {
                        flag = NO;
                        break;                
                    }
                }
            } else if ((x == x1) && (y>y1)) {
                for (i=(y1+1); i<y; i++) {
                    if ([_board[x][i] boardCellKomaKind] != KOMA_NASHI) {
                        flag = NO;
                        break;                
                    }
                }            
            } else if ((y == y1) && (x<x1)) {
                for (i=(x+1); i<x1; i++) {
                    if ([_board[i][y] boardCellKomaKind] != KOMA_NASHI) {
                        flag = NO;
                        break;                
                    }
                }
            } else if ((y == y1) && (x>x1)) {
                for (i=(x1+1); i<x; i++) {
                    if ([_board[i][y] boardCellKomaKind] != KOMA_NASHI) {
                        flag = NO;
                        break;                
                    }
                }
            } else {
                flag = NO;
            }
            break;
        case SENTE_UMA:
        case GOTE_UMA:
            if ((((x1-1) <= x) && (x <= (x1+1))) &&
                (((y1-1) <= y) && (y <= (y1+1)))) {
                flag = YES;
                break;
            }           
        case SENTE_KAKU:
        case GOTE_KAKU:
            mx = x - x1;
            my = y - y1;
            if (abs(mx) == abs(my)) {
                if ((mx < 0) && (my > 0)) {
                    for (i = x+1, j=y-1; i<x1; i++, j--) {
                        if ([_board[i][j] boardCellKomaKind] != KOMA_NASHI) {
                            flag = NO;
                            break;
                        }
                    }
                } else if ((mx < 0) && (my < 0)) {
                    for (i=x+1,j=y+1; i<x1; i++,j++) {
                        if ([_board[i][j] boardCellKomaKind] != KOMA_NASHI) {
                            flag = NO;
                            break;                
                        }
                    }
                } else if ((mx > 0) && (my > 0)) {
                    for (i=x1+1,j=y1+1; i<x; i++,j++) {
                        if ([_board[i][j] boardCellKomaKind] != KOMA_NASHI) {
                            flag = NO;
                            break;                
                        }
                    }
                } else if ((mx > 0) && (my < 0)) {
                    for (i=x1+1,j=y1-1; i<x; i++,j--) {
                        if ([_board[i][j] boardCellKomaKind] != KOMA_NASHI) {
                            flag = NO;
                            break;                
                        }
                    }
                }
            } else {
                flag = NO;
            }
            break;
        case SENTE_KIN:
        case SENTE_NARIGIN:
        case SENTE_NARIKEI:
        case SENTE_NARIKYOU:
        case SENTE_TO:
            if ((((x1-1) <=  x) && (x <= (x1+1))) &&
                ((y1 <=  y) && (y <= (y1+1))))
                flag = YES;
            else if ((x == x1) && (y == (y1-1)))
                flag = YES;
            else 
                flag = NO;
            break;
        case SENTE_GIN:
            if ((((x1-1) <=  x) && (x <= (x1+1))) &&
                (y1 == (y-1)))
                flag = YES;
            else if ((x == (x1+1)) && (y == (y1-1)))
                flag = YES;
            else if ((x == (x1-1)) && (y == (y1-1)))
                flag = YES;
            else 
                flag = NO;
            break;        
        case SENTE_KEIMA:
            if ((x == (x1+1)) && (y == (y1+2)))
                flag = YES;
            else if ((x == (x1-1)) && (y == (y1+2)))
                flag = YES;
            else 
                flag = NO;
            break;
        case SENTE_KYOUSYA:
            if ((x == x1) && (y > y1)) {
                flag = YES;
                for (i=(y1+1); i<y; i++) {
                    if ([_board[x][i] boardCellKomaKind] != KOMA_NASHI) {
                        flag = NO;
                        break;
                    }
                }            
            } else {
                flag = NO;
            }
            break;
        case SENTE_FU:
            if ((x == x1) && (y == (y1+1))) {
                flag = YES; 
            } else {
                flag = NO; 
            }
            break;
        case GOTE_KIN:
        case GOTE_NARIGIN:
        case GOTE_NARIKEI:
        case GOTE_NARIKYOU:
        case GOTE_TO:
            if ((((x1-1) <=  x) && (x <= (x1+1))) &&
                (((y1-1) <=  y) && (y <= y1)))
                flag = YES;
            else if ((x == x1) && (y == (y1+1)))
                flag = YES;
            else 
                flag = NO;
            break;
        case GOTE_GIN:
            if ((((x1-1) <=  x) && (x <= (x1+1))) &&
                (y1 ==  (y+1)))
                flag = YES;
            else if ((x == (x1-1)) && (y == (y1+1)))
                flag = YES;
            else if ((x == (x1+1)) && (y == (y1+1)))
                flag = YES;
            else 
                flag = NO;
            break;
        case GOTE_KEIMA:
            if ((x == (x1+1)) && (y == (y1-2)))
                flag = YES;
            else if ((x == (x1-1)) && (y == (y1-2)))
                flag = YES;
            else 
                flag = NO;
            break;
        case GOTE_KYOUSYA:
            if ((x == x1) && (y < y1)) {
                flag = YES;
                for (i=(y1-1); i>y; i--) {
                    if ([_board[x][i] boardCellKomaKind] != KOMA_NASHI) {
                        flag = NO;
                        break;
                    }
                }            
            } else {
                flag = NO;
            }
            break;
        case GOTE_FU:
            if ((x == x1) && (y == (y1-1))) {
                flag = YES; 
            } else {
                flag = NO; 
            }
            break;
        }

    return flag;
}

// ɓo^
- (void)makeKif {

//NSLog(@"s x:%d y:%d koma:%d", [_boardSource boardCellX],[_boardSource boardCellY],
//[_boardSource boardCellKomaKind]);

//NSLog(@"d x:%d y:%d koma:%d", [_boardDestination boardCellX],[_boardDestination //boardCellY],
//[_boardDestination boardCellKomaKind]);

    [_ykifController addKifController:_boardSource :_boardDestination 
        :_boardPlace :_boardStock];

//   [_boardView setNeedsDisplay:YES];
}
	
- (void)dealloc {
   int i, j;
    
    for (i=0; i<MAX_WIDTH; i++) {
        for (j=0; j<MAX_HEIGHT; j++) {
            [_board[i][j] release];
        }
    }

    [_boardDrag release];
    [_boardStock release];
    [_boardPlace release];
    [_boardSource release];
    [_boardDestination release];
    [_boardSheetDrag release];

    [super dealloc];
}

@end
